﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;

namespace DA
{
    public static class MessagesDataAdapter
    {

        static string connectionString = DA.Settings.Default.connectionString;
       // static string connectionString = @"data source=.\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=C:\sncdb_naseer\Database1.mdf;User Instance=true";
       
        static public List<string[]> GetIncomingMessagesByUserId(int userId)
        {
            List<string[]> messages = new List<string[]>();

            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Select * FROM messages Where AddresseeId = @userId AND Type = 1";

            command.Parameters.AddWithValue("@userId", userId);

            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                while (reader.Read())
                {
                    messages.Add(new string[] { reader[0].ToString(), reader[1].ToString(), reader[2].ToString(), reader[3].ToString(), reader[4].ToString(), reader[5].ToString(), reader[6].ToString() });
                }

            }
            finally
            {
                connection.Close();
            }
            return messages;
        }
        static public List<string[]> GetIncomingMessagesByCompanyId(int companyId)
        {
            List<string[]> messages = new List<string[]>();

            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Select * FROM messages Where AddresseeId = @userId AND Type = 2";

            command.Parameters.AddWithValue("@userId", companyId);

            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                while (reader.Read())
                {
                    messages.Add(new string[] { reader[0].ToString(), reader[1].ToString(), reader[2].ToString(), reader[3].ToString(), reader[4].ToString(), reader[5].ToString(), reader[6].ToString() });
                }

            }
            finally
            {
                connection.Close();
            }
            return messages;
        }
        static public List<string[]> GetOutgoingMessagesByUserId(int userId)
        {
            List<string[]> messages = new List<string[]>();

            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Select * FROM messages Where SenderId = @userId AND Type = 1";

            command.Parameters.AddWithValue("@userId", userId);

            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                while (reader.Read())
                {
                    messages.Add(new string[] { reader[0].ToString(), reader[1].ToString(), reader[2].ToString(), reader[3].ToString(), reader[4].ToString(), reader[5].ToString(), reader[6].ToString() });
                }

            }
            finally
            {
                connection.Close();
            }
            return messages;
        }
        static public List<string[]> GetOutgoingMessagesByCompanyId(int companyId)
        {
            List<string[]> messages = new List<string[]>();

            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Select * FROM messages Where SenderId = @userId AND Type = 2";

            command.Parameters.AddWithValue("@userId", companyId);

            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                while (reader.Read())
                {
                    messages.Add(new string[] { reader[0].ToString(), reader[1].ToString(), reader[2].ToString(), reader[3].ToString(), reader[4].ToString(), reader[5].ToString(), reader[6].ToString() });
                }

            }
            finally
            {
                connection.Close();
            }
            return messages;
        }
        static public void SendMessage(int senderId, int addresseeId, string messageTopic, string messageText)
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Insert INTO Messages (SenderId, AddresseeId, MessageTopic, MessageText, MessageDate, IsRead, Type)"+
            "values(@senderId, @addresseeId, @messageTopic, @messageText, @messagedate, 'False', 1)";

            command.Parameters.AddWithValue("@senderId", senderId);
            command.Parameters.AddWithValue("@addresseeId", addresseeId);
            command.Parameters.AddWithValue("@messageTopic", messageTopic);
            command.Parameters.AddWithValue("@messageText", messageText);
            command.Parameters.AddWithValue("@messagedate", DateTime.Now);

            try
            {
                connection.Open();
                command.ExecuteNonQuery();
            }
            finally
            {
                connection.Close();
            }
        }
        static public void SendMessageToCompany(int senderId, int addresseeId, string messageTopic, string messageText)
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Insert INTO Messages (SenderId, AddresseeId, MessageTopic, MessageText, MessageDate, IsRead, Type)" +
            "values(@senderId, @addresseeId, @messageTopic, @messageText, @messagedate, 'False', 2)";

            command.Parameters.AddWithValue("@senderId", senderId);
            command.Parameters.AddWithValue("@addresseeId", addresseeId);
            command.Parameters.AddWithValue("@messageTopic", messageTopic);
            command.Parameters.AddWithValue("@messageText", messageText);
            command.Parameters.AddWithValue("@messagedate", DateTime.Now);

            try
            {
                connection.Open();
                command.ExecuteNonQuery();
            }
            finally
            {
                connection.Close();
            }
        }
    }
}
