﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Data.SqlClient;

namespace DA
{
    public static class UserDataAdapter
    {
        static string connectionString = DA.Settings.Default.connectionString;

        static public int CreateUser(string username, string userPassword, string firstName,
            string lastName, string role, string email, string position,string imageName)
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Insert into Users (username, password , first_name , "+
            "last_name, email, role, position,image) values(@username, @password, @firstName, @lastName, @email, @role, @position,@imageName);" +
            "Select SCOPE_IDENTITY()";

            command.Parameters.AddWithValue("@username", username);
            command.Parameters.AddWithValue("@password", userPassword);
            command.Parameters.AddWithValue("@firstName", firstName);
            command.Parameters.AddWithValue("@lastName", lastName);
            command.Parameters.AddWithValue("@email", email);
            command.Parameters.AddWithValue("@role", role);
            command.Parameters.AddWithValue("@position", position);
            command.Parameters.AddWithValue("@imageName", imageName);

            int i = 0;
            try
            {
                connection.Open();
                i = int.Parse(command.ExecuteScalar().ToString());
            }
            finally
            {
                connection.Close();
            }
            return i;
        }

        static public string[] FindUser(int userId)
        {
            string[] users = new string[10];

            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandText = "Select * from users where id=@userId";
            command.Parameters.AddWithValue("@userId", userId);

            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                while (reader.Read())
                {
                    users = new string[] { reader["id"].ToString(), reader["username"].ToString(), reader["role"].ToString(), reader["image"].ToString() };
                }
            }
            finally
            {
                connection.Close();
            }
            return users;
        }
        static public string[] GetUserInfoById(int userId)
        {
            string[] userInfo;
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandText = "Select first_name, last_name, image from users where id=@userId";
            command.Parameters.AddWithValue("@userId", userId);

            try
            {
                connection.Open();
                SqlDataReader reader = command.ExecuteReader();
                reader.Read();
                userInfo = new string[] { reader[0].ToString(), reader[1].ToString(), reader[2].ToString() };
            }
            finally
            {
                connection.Close();
            }
            return userInfo;
        }
        static public int ValidateUser(string username, string userPassword)
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;

            command.CommandText = "Select id From users WHERE username=@username and password=@password";

            command.Parameters.AddWithValue("@username", username);
            command.Parameters.AddWithValue("@password", userPassword);

            int i = 0;
            try
            {
                connection.Open();
                i = int.Parse(command.ExecuteScalar().ToString());
            }
            finally
            {
                connection.Close();
            }
            return i;
        }


        public static string GetUsernameById(int userId)
        {
            string userName;
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = connection.CreateCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandText = "Select username from users where id=@userId";
            command.Parameters.AddWithValue("@userId", userId);

            try
            {
                connection.Open();
                userName = command.ExecuteScalar().ToString();
            }
            finally
            {
                connection.Close();
            }
            return userName;
        }
    }
}
